Package com.google.android.exoplayer2.extractor.mp4

## Class FragmentedMp4Extractor

- java.lang.Object
- - com.google.android.exoplayer2.extractor.mp4.FragmentedMp4Extractor

- All Implemented Interfaces:
    `Extractor`

      public class FragmentedMp4Extractor
      extends Object
      implements Extractor

  Extracts data from the FMP4 container format.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static interface` | `FragmentedMp4Extractor.Flags` | Flags controlling the behavior of the extractor.

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `Extractor.ReadResult`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ExtractorsFactory` | `FACTORY` | Factory for `FragmentedMp4Extractor` instances.
    `static int` | `FLAG_ENABLE_EMSG_TRACK` | Flag to indicate that the extractor should output an event message metadata track.
    `static int` | `FLAG_WORKAROUND_EVERY_VIDEO_FRAME_IS_SYNC_FRAME` | Flag to work around an issue in some video streams where every frame is marked as a sync frame.
    `static int` | `FLAG_WORKAROUND_IGNORE_EDIT_LISTS` | Flag to ignore any edit lists in the stream.
    `static int` | `FLAG_WORKAROUND_IGNORE_TFDT_BOX` | Flag to ignore any tfdt boxes in the stream.

    - ### Fields inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `RESULT_CONTINUE, RESULT_END_OF_INPUT, RESULT_SEEK`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FragmentedMp4Extractor()` |
    `FragmentedMp4Extractor​(int flags)` |
    `FragmentedMp4Extractor​(int flags, TimestampAdjuster timestampAdjuster)` |
    `FragmentedMp4Extractor​(int flags, TimestampAdjuster timestampAdjuster, Track sideloadedTrack)` |
    `FragmentedMp4Extractor​(int flags, TimestampAdjuster timestampAdjuster, Track sideloadedTrack, List<Format> closedCaptionFormats)` |
    `FragmentedMp4Extractor​(int flags, TimestampAdjuster timestampAdjuster, Track sideloadedTrack, List<Format> closedCaptionFormats, TrackOutput additionalEmsgTrackOutput)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `init​(ExtractorOutput output)` | Initializes the extractor with an `ExtractorOutput`.
    `protected Track` | `modifyTrack​(Track track)` |
    `int` | `read​(ExtractorInput input, PositionHolder seekPosition)` | Extracts data read from a provided `ExtractorInput`.
    `void` | `release()` | Releases all kept resources.
    `void` | `seek​(long position, long timeUs)` | Notifies the extractor that a seek has occurred.
    `boolean` | `sniff​(ExtractorInput input)` | Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FACTORY

          public static final ExtractorsFactory FACTORY

      Factory for `FragmentedMp4Extractor` instances.

    - #### FLAG_WORKAROUND_EVERY_VIDEO_FRAME_IS_SYNC_FRAME

          public static final int FLAG_WORKAROUND_EVERY_VIDEO_FRAME_IS_SYNC_FRAME

      Flag to work around an issue in some video streams where every frame is marked as a sync frame. The workaround overrides the sync frame flags in the stream, forcing them to false except for the first sample in each segment.

      This flag does nothing if the stream is not a video stream.

      See Also:
        Constant Field Values

    - #### FLAG_WORKAROUND_IGNORE_TFDT_BOX

          public static final int FLAG_WORKAROUND_IGNORE_TFDT_BOX

      Flag to ignore any tfdt boxes in the stream.
      See Also:
        Constant Field Values

    - #### FLAG_ENABLE_EMSG_TRACK

          public static final int FLAG_ENABLE_EMSG_TRACK

      Flag to indicate that the extractor should output an event message metadata track. Any event messages in the stream will be delivered as samples to this track.
      See Also:
        Constant Field Values

    - #### FLAG_WORKAROUND_IGNORE_EDIT_LISTS

          public static final int FLAG_WORKAROUND_IGNORE_EDIT_LISTS

      Flag to ignore any edit lists in the stream.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor()

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor​(@Flags
                                        int flags)

      Parameters:
        `flags` - Flags that control the extractor's behavior.

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor​(@Flags
                                        int flags,
                                        @Nullable
                                        TimestampAdjuster timestampAdjuster)

      Parameters:
        `flags` - Flags that control the extractor's behavior.
        `timestampAdjuster` - Adjusts sample timestamps. May be null if no adjustment is needed.

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor​(@Flags
                                        int flags,
                                        @Nullable
                                        TimestampAdjuster timestampAdjuster,
                                        @Nullable
                                        Track sideloadedTrack)

      Parameters:
        `flags` - Flags that control the extractor's behavior.
        `timestampAdjuster` - Adjusts sample timestamps. May be null if no adjustment is needed.
        `sideloadedTrack` - Sideloaded track information, in the case that the extractor will not receive a moov box in the input data. Null if a moov box is expected.

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor​(@Flags
                                        int flags,
                                        @Nullable
                                        TimestampAdjuster timestampAdjuster,
                                        @Nullable
                                        Track sideloadedTrack,
                                        List<Format> closedCaptionFormats)

      Parameters:
        `flags` - Flags that control the extractor's behavior.
        `timestampAdjuster` - Adjusts sample timestamps. May be null if no adjustment is needed.
        `sideloadedTrack` - Sideloaded track information, in the case that the extractor will not receive a moov box in the input data. Null if a moov box is expected.
        `closedCaptionFormats` - For tracks that contain SEI messages, the formats of the closed caption channels to expose.

    - #### FragmentedMp4Extractor

          public FragmentedMp4Extractor​(@Flags
                                        int flags,
                                        @Nullable
                                        TimestampAdjuster timestampAdjuster,
                                        @Nullable
                                        Track sideloadedTrack,
                                        List<Format> closedCaptionFormats,
                                        @Nullable
                                        TrackOutput additionalEmsgTrackOutput)

      Parameters:
        `flags` - Flags that control the extractor's behavior.
        `timestampAdjuster` - Adjusts sample timestamps. May be null if no adjustment is needed.
        `sideloadedTrack` - Sideloaded track information, in the case that the extractor will not receive a moov box in the input data. Null if a moov box is expected.
        `closedCaptionFormats` - For tracks that contain SEI messages, the formats of the closed caption channels to expose.
        `additionalEmsgTrackOutput` - An extra track output that will receive all emsg messages targeting the player, even if `FLAG_ENABLE_EMSG_TRACK` is not set. Null if special handling of emsg messages for players is not required.

  - ### Method Detail

    - #### sniff

          public boolean sniff​(ExtractorInput input)
                        throws IOException

      Description copied from interface: `Extractor`
      Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

      If `true` is returned, the `input`'s reading position may have been modified. Otherwise, only its peek position may have been modified.

      Specified by:
        `sniff` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be peeked/read.
      Returns:
        Whether this extractor can read the provided input.
      Throws:
        `IOException` - If an error occurred reading from the input.

    - #### init

          public void init​(ExtractorOutput output)

      Description copied from interface: `Extractor`
      Initializes the extractor with an `ExtractorOutput`. Called at most once.
      Specified by:
        `init` in interface `Extractor`
      Parameters:
        `output` - An `ExtractorOutput` to receive extracted data.

    - #### seek

          public void seek​(long position,
                           long timeUs)

      Description copied from interface: `Extractor`
      Notifies the extractor that a seek has occurred.

      Following a call to this method, the `ExtractorInput` passed to the next invocation of `Extractor.read(ExtractorInput, PositionHolder)` is required to provide data starting from `position` in the stream. Valid random access positions are the start of the stream and positions that can be obtained from any `SeekMap` passed to the `ExtractorOutput`.

      Specified by:
        `seek` in interface `Extractor`
      Parameters:
        `position` - The byte offset in the stream from which data will be provided.
        `timeUs` - The seek time in microseconds.

    - #### release

          public void release()

      Description copied from interface: `Extractor`
      Releases all kept resources.
      Specified by:
        `release` in interface `Extractor`

    - #### read

          public int read​(ExtractorInput input,
                          PositionHolder seekPosition)
                   throws IOException

      Description copied from interface: `Extractor`
      Extracts data read from a provided `ExtractorInput`. Must not be called before `Extractor.init(ExtractorOutput)`.

      A single call to this method will block until some progress has been made, but will not block for longer than this. Hence each call will consume only a small amount of input data.

      In the common case, `Extractor.RESULT_CONTINUE` is returned to indicate that the `ExtractorInput` passed to the next read is required to provide data continuing from the position in the stream reached by the returning call. If the extractor requires data to be provided from a different position, then that position is set in `seekPosition` and `Extractor.RESULT_SEEK` is returned. If the extractor reached the end of the data provided by the `ExtractorInput`, then `Extractor.RESULT_END_OF_INPUT` is returned.

      When this method throws an `IOException`, extraction may continue by providing an `ExtractorInput` with an unchanged `read position` to a subsequent call to this method.

      Specified by:
        `read` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be read.
        `seekPosition` - If `Extractor.RESULT_SEEK` is returned, this holder is updated to hold the position of the required data.
      Returns:
        One of the `RESULT_` values defined in this interface.
      Throws:
        `IOException` - If an error occurred reading from or parsing the input.

    - #### modifyTrack

          @Nullable
          protected Track modifyTrack​(@Nullable
                                      Track track)